/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_mechanism/pr2_mechanism_msgs/msg/ActuatorStatistics.msg.  Do not edit! */
#ifndef PR2_MECHANISM_MSGS_ACTUATORSTATISTICS_H
#define PR2_MECHANISM_MSGS_ACTUATORSTATISTICS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace pr2_mechanism_msgs
{

//! \htmlinclude ActuatorStatistics.msg.html

class ActuatorStatistics : public ros::Message
{
public:
  typedef boost::shared_ptr<ActuatorStatistics> Ptr;
  typedef boost::shared_ptr<ActuatorStatistics const> ConstPtr;

  typedef std::string _name_type;
  typedef int32_t _device_id_type;
  typedef ros::Time _timestamp_type;
  typedef int32_t _encoder_count_type;
  typedef double _encoder_offset_type;
  typedef double _position_type;
  typedef double _encoder_velocity_type;
  typedef double _velocity_type;
  typedef uint8_t _calibration_reading_type;
  typedef uint8_t _calibration_rising_edge_valid_type;
  typedef uint8_t _calibration_falling_edge_valid_type;
  typedef double _last_calibration_rising_edge_type;
  typedef double _last_calibration_falling_edge_type;
  typedef uint8_t _is_enabled_type;
  typedef uint8_t _halted_type;
  typedef double _last_commanded_current_type;
  typedef double _last_commanded_effort_type;
  typedef double _last_executed_current_type;
  typedef double _last_executed_effort_type;
  typedef double _last_measured_current_type;
  typedef double _last_measured_effort_type;
  typedef double _motor_voltage_type;
  typedef int32_t _num_encoder_errors_type;

  std::string name;
  int32_t device_id;
  ros::Time timestamp;
  int32_t encoder_count;
  double encoder_offset;
  double position;
  double encoder_velocity;
  double velocity;
  uint8_t calibration_reading;
  uint8_t calibration_rising_edge_valid;
  uint8_t calibration_falling_edge_valid;
  double last_calibration_rising_edge;
  double last_calibration_falling_edge;
  uint8_t is_enabled;
  uint8_t halted;
  double last_commanded_current;
  double last_commanded_effort;
  double last_executed_current;
  double last_executed_effort;
  double last_measured_current;
  double last_measured_effort;
  double motor_voltage;
  int32_t num_encoder_errors;

  ActuatorStatistics() : ros::Message(),
    device_id(0),
    encoder_count(0),
    encoder_offset(0),
    position(0),
    encoder_velocity(0),
    velocity(0),
    calibration_reading(0),
    calibration_rising_edge_valid(0),
    calibration_falling_edge_valid(0),
    last_calibration_rising_edge(0),
    last_calibration_falling_edge(0),
    is_enabled(0),
    halted(0),
    last_commanded_current(0),
    last_commanded_effort(0),
    last_executed_current(0),
    last_executed_effort(0),
    last_measured_current(0),
    last_measured_effort(0),
    motor_voltage(0),
    num_encoder_errors(0)
  {
  }
  ActuatorStatistics(const ActuatorStatistics &copy) : ros::Message(),
    name(copy.name),
    device_id(copy.device_id),
    timestamp(copy.timestamp),
    encoder_count(copy.encoder_count),
    encoder_offset(copy.encoder_offset),
    position(copy.position),
    encoder_velocity(copy.encoder_velocity),
    velocity(copy.velocity),
    calibration_reading(copy.calibration_reading),
    calibration_rising_edge_valid(copy.calibration_rising_edge_valid),
    calibration_falling_edge_valid(copy.calibration_falling_edge_valid),
    last_calibration_rising_edge(copy.last_calibration_rising_edge),
    last_calibration_falling_edge(copy.last_calibration_falling_edge),
    is_enabled(copy.is_enabled),
    halted(copy.halted),
    last_commanded_current(copy.last_commanded_current),
    last_commanded_effort(copy.last_commanded_effort),
    last_executed_current(copy.last_executed_current),
    last_executed_effort(copy.last_executed_effort),
    last_measured_current(copy.last_measured_current),
    last_measured_effort(copy.last_measured_effort),
    motor_voltage(copy.motor_voltage),
    num_encoder_errors(copy.num_encoder_errors)
  {
    (void)copy;
  }
  ActuatorStatistics &operator =(const ActuatorStatistics &copy)
  {
    if (this == &copy)
      return *this;
    name = copy.name;
    device_id = copy.device_id;
    timestamp = copy.timestamp;
    encoder_count = copy.encoder_count;
    encoder_offset = copy.encoder_offset;
    position = copy.position;
    encoder_velocity = copy.encoder_velocity;
    velocity = copy.velocity;
    calibration_reading = copy.calibration_reading;
    calibration_rising_edge_valid = copy.calibration_rising_edge_valid;
    calibration_falling_edge_valid = copy.calibration_falling_edge_valid;
    last_calibration_rising_edge = copy.last_calibration_rising_edge;
    last_calibration_falling_edge = copy.last_calibration_falling_edge;
    is_enabled = copy.is_enabled;
    halted = copy.halted;
    last_commanded_current = copy.last_commanded_current;
    last_commanded_effort = copy.last_commanded_effort;
    last_executed_current = copy.last_executed_current;
    last_executed_effort = copy.last_executed_effort;
    last_measured_current = copy.last_measured_current;
    last_measured_effort = copy.last_measured_effort;
    motor_voltage = copy.motor_voltage;
    num_encoder_errors = copy.num_encoder_errors;
    return *this;
  }
  virtual ~ActuatorStatistics() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_mechanism_msgs/ActuatorStatistics"); }
  inline static std::string __s_getMD5Sum() { return std::string("c37184273b29627de29382f1d3670175"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains the state of an actuator on the pr2 robot.\n"
    "# An actuator contains a motor and an encoder, and is connected\n"
    "# to a joint by a transmission\n"
    "\n"
    "# the name of the actuator\n"
    "string name\n"
    "\n"
    "# the sequence number of the MCB in the ethercat chain. \n"
    "# the first device in the chain gets deviced_id zero\n"
    "int32 device_id\n"
    "\n"
    "# the time at which this actuator state was measured\n"
    "time timestamp\n"
    "\n"
    "# the encoder position, represented by the number of encoder ticks\n"
    "int32 encoder_count\n"
    "\n"
    "# The angular offset (in radians) that is added to the encoder reading, \n"
    "# to get to the position of the actuator. This number is computed when the referece\n"
    "# sensor is triggered during the calibration phase\n"
    "float64 encoder_offset\n"
    "\n"
    "# the encoder position in radians\n"
    "float64 position\n"
    "\n"
    "# the encoder velocity in encoder ticks per second\n"
    "float64 encoder_velocity\n"
    "\n"
    "# the encoder velocity in radians per second\n"
    "float64 velocity\n"
    "\n"
    "# the value of the calibration reading: low (false) or high (true)\n"
    "bool calibration_reading\n"
    "\n"
    "# bool to indicate if the joint already triggered the rising/falling edge of the reference sensor\n"
    "bool calibration_rising_edge_valid\n"
    "bool calibration_falling_edge_valid\n"
    "\n"
    "# the encoder position when the last rising/falling edge was observed. \n"
    "# only read this value when the calibration_rising/falling_edge_valid is true\n"
    "float64 last_calibration_rising_edge\n"
    "float64 last_calibration_falling_edge\n"
    "\n"
    "# flag to indicate if this actuator is enabled or not. \n"
    "# An actuator can only be commanded when it is enabled.\n"
    "bool is_enabled\n"
    "\n"
    "# indicates if the motor is halted. A motor can be halted because of a voltage or communication problem\n"
    "bool halted\n"
    "\n"
    "# the last current/effort command that was requested\n"
    "float64 last_commanded_current\n"
    "float64 last_commanded_effort\n"
    "\n"
    "# the last current/effort command that was executed by the actuator\n"
    "float64 last_executed_current\n"
    "float64 last_executed_effort\n"
    "\n"
    "# the last current/effort that was measured by the actuator\n"
    "float64 last_measured_current\n"
    "float64 last_measured_effort\n"
    "\n"
    "# the motor voltate\n"
    "float64 motor_voltage\n"
    "\n"
    "# the number of detected encoder problems \n"
    "int32 num_encoder_errors\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + name.length(); // name
    __l += 4; // device_id
    __l += 8; // timestamp
    __l += 4; // encoder_count
    __l += 8; // encoder_offset
    __l += 8; // position
    __l += 8; // encoder_velocity
    __l += 8; // velocity
    __l += 1; // calibration_reading
    __l += 1; // calibration_rising_edge_valid
    __l += 1; // calibration_falling_edge_valid
    __l += 8; // last_calibration_rising_edge
    __l += 8; // last_calibration_falling_edge
    __l += 1; // is_enabled
    __l += 1; // halted
    __l += 8; // last_commanded_current
    __l += 8; // last_commanded_effort
    __l += 8; // last_executed_current
    __l += 8; // last_executed_effort
    __l += 8; // last_measured_current
    __l += 8; // last_measured_effort
    __l += 8; // motor_voltage
    __l += 4; // num_encoder_errors
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_name_len = name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, name.c_str(), __ros_name_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, device_id);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timestamp.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timestamp.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, encoder_count);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, encoder_offset);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, position);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, encoder_velocity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, velocity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, calibration_reading);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, calibration_rising_edge_valid);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, calibration_falling_edge_valid);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_calibration_rising_edge);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_calibration_falling_edge);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, is_enabled);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, halted);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_commanded_current);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_commanded_effort);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_executed_current);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_executed_effort);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_measured_current);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, last_measured_effort);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, motor_voltage);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, num_encoder_errors);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_len);
    name = std::string((const char *)read_ptr, __ros_name_len);
    read_ptr += __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, device_id);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timestamp.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timestamp.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, encoder_count);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, encoder_offset);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, position);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, encoder_velocity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, velocity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, calibration_reading);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, calibration_rising_edge_valid);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, calibration_falling_edge_valid);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_calibration_rising_edge);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_calibration_falling_edge);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, is_enabled);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, halted);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_commanded_current);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_commanded_effort);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_executed_current);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_executed_effort);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_measured_current);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, last_measured_effort);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, motor_voltage);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, num_encoder_errors);
    return read_ptr;
  }
};

typedef boost::shared_ptr<ActuatorStatistics> ActuatorStatisticsPtr;
typedef boost::shared_ptr<ActuatorStatistics const> ActuatorStatisticsConstPtr;


}

#endif
