/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_mechanism/pr2_mechanism_msgs/msg/ControllerStatistics.msg.  Do not edit! */
#ifndef PR2_MECHANISM_MSGS_CONTROLLERSTATISTICS_H
#define PR2_MECHANISM_MSGS_CONTROLLERSTATISTICS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace pr2_mechanism_msgs
{

//! \htmlinclude ControllerStatistics.msg.html

class ControllerStatistics : public ros::Message
{
public:
  typedef boost::shared_ptr<ControllerStatistics> Ptr;
  typedef boost::shared_ptr<ControllerStatistics const> ConstPtr;

  typedef std::string _name_type;
  typedef ros::Time _timestamp_type;
  typedef uint8_t _running_type;
  typedef ros::Duration _max_time_type;
  typedef ros::Duration _mean_time_type;
  typedef ros::Duration _variance_time_type;
  typedef int32_t _num_control_loop_overruns_type;
  typedef ros::Time _time_last_control_loop_overrun_type;

  std::string name;
  ros::Time timestamp;
  uint8_t running;
  ros::Duration max_time;
  ros::Duration mean_time;
  ros::Duration variance_time;
  int32_t num_control_loop_overruns;
  ros::Time time_last_control_loop_overrun;

  ControllerStatistics() : ros::Message(),
    running(0),
    num_control_loop_overruns(0)
  {
  }
  ControllerStatistics(const ControllerStatistics &copy) : ros::Message(),
    name(copy.name),
    timestamp(copy.timestamp),
    running(copy.running),
    max_time(copy.max_time),
    mean_time(copy.mean_time),
    variance_time(copy.variance_time),
    num_control_loop_overruns(copy.num_control_loop_overruns),
    time_last_control_loop_overrun(copy.time_last_control_loop_overrun)
  {
    (void)copy;
  }
  ControllerStatistics &operator =(const ControllerStatistics &copy)
  {
    if (this == &copy)
      return *this;
    name = copy.name;
    timestamp = copy.timestamp;
    running = copy.running;
    max_time = copy.max_time;
    mean_time = copy.mean_time;
    variance_time = copy.variance_time;
    num_control_loop_overruns = copy.num_control_loop_overruns;
    time_last_control_loop_overrun = copy.time_last_control_loop_overrun;
    return *this;
  }
  virtual ~ControllerStatistics() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_mechanism_msgs/ControllerStatistics"); }
  inline static std::string __s_getMD5Sum() { return std::string("6d15d137eea402018e3c7c8dbecd4b95"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains the state of one realtime controller\n"
    "# that was spawned in pr2_mechanism_control\n"
    "\n"
    "# the name of the controller\n"
    "string name\n"
    "\n"
    "# the time at which these controller statistics were measured\n"
    "time timestamp\n"
    "\n"
    "# bool that indicates if the controller is currently\n"
    "# in a running or a stopped state\n"
    "bool running\n"
    "\n"
    "# the maximum time the update loop of the controller ever needed to complete\n"
    "duration max_time\n"
    "\n"
    "# the average time the update loop of the controller needs to complete. \n"
    "# the average is computed in a sliding time window.\n"
    "duration mean_time\n"
    "\n"
    "# the variance on the time the update loop of the controller needs to complete.\n"
    "# the variance applies to a sliding time window.\n"
    "duration variance_time\n"
    "\n"
    "# the number of times this controller broke the realtime loop\n"
    "int32 num_control_loop_overruns\n"
    "\n"
    "# the timestamp of the last time this controller broke the realtime loop\n"
    "time time_last_control_loop_overrun\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + name.length(); // name
    __l += 8; // timestamp
    __l += 1; // running
    __l += 8; // max_time
    __l += 8; // mean_time
    __l += 8; // variance_time
    __l += 4; // num_control_loop_overruns
    __l += 8; // time_last_control_loop_overrun
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_name_len = name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, name.c_str(), __ros_name_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timestamp.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timestamp.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, running);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_time.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_time.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, mean_time.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, mean_time.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, variance_time.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, variance_time.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, num_control_loop_overruns);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_last_control_loop_overrun.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_last_control_loop_overrun.nsec);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_len);
    name = std::string((const char *)read_ptr, __ros_name_len);
    read_ptr += __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timestamp.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timestamp.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, running);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_time.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_time.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, mean_time.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, mean_time.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, variance_time.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, variance_time.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, num_control_loop_overruns);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_last_control_loop_overrun.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_last_control_loop_overrun.nsec);
    return read_ptr;
  }
};

typedef boost::shared_ptr<ControllerStatistics> ControllerStatisticsPtr;
typedef boost::shared_ptr<ControllerStatistics const> ControllerStatisticsConstPtr;


}

#endif
