/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_mechanism/pr2_mechanism_msgs/msg/JointStatistics.msg.  Do not edit! */
#ifndef PR2_MECHANISM_MSGS_JOINTSTATISTICS_H
#define PR2_MECHANISM_MSGS_JOINTSTATISTICS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace pr2_mechanism_msgs
{

//! \htmlinclude JointStatistics.msg.html

class JointStatistics : public ros::Message
{
public:
  typedef boost::shared_ptr<JointStatistics> Ptr;
  typedef boost::shared_ptr<JointStatistics const> ConstPtr;

  typedef std::string _name_type;
  typedef ros::Time _timestamp_type;
  typedef double _position_type;
  typedef double _velocity_type;
  typedef double _measured_effort_type;
  typedef double _commanded_effort_type;
  typedef uint8_t _is_calibrated_type;
  typedef uint8_t _violated_limits_type;
  typedef double _odometer_type;
  typedef double _min_position_type;
  typedef double _max_position_type;
  typedef double _max_abs_velocity_type;
  typedef double _max_abs_effort_type;

  std::string name;
  ros::Time timestamp;
  double position;
  double velocity;
  double measured_effort;
  double commanded_effort;
  uint8_t is_calibrated;
  uint8_t violated_limits;
  double odometer;
  double min_position;
  double max_position;
  double max_abs_velocity;
  double max_abs_effort;

  JointStatistics() : ros::Message(),
    position(0),
    velocity(0),
    measured_effort(0),
    commanded_effort(0),
    is_calibrated(0),
    violated_limits(0),
    odometer(0),
    min_position(0),
    max_position(0),
    max_abs_velocity(0),
    max_abs_effort(0)
  {
  }
  JointStatistics(const JointStatistics &copy) : ros::Message(),
    name(copy.name),
    timestamp(copy.timestamp),
    position(copy.position),
    velocity(copy.velocity),
    measured_effort(copy.measured_effort),
    commanded_effort(copy.commanded_effort),
    is_calibrated(copy.is_calibrated),
    violated_limits(copy.violated_limits),
    odometer(copy.odometer),
    min_position(copy.min_position),
    max_position(copy.max_position),
    max_abs_velocity(copy.max_abs_velocity),
    max_abs_effort(copy.max_abs_effort)
  {
    (void)copy;
  }
  JointStatistics &operator =(const JointStatistics &copy)
  {
    if (this == &copy)
      return *this;
    name = copy.name;
    timestamp = copy.timestamp;
    position = copy.position;
    velocity = copy.velocity;
    measured_effort = copy.measured_effort;
    commanded_effort = copy.commanded_effort;
    is_calibrated = copy.is_calibrated;
    violated_limits = copy.violated_limits;
    odometer = copy.odometer;
    min_position = copy.min_position;
    max_position = copy.max_position;
    max_abs_velocity = copy.max_abs_velocity;
    max_abs_effort = copy.max_abs_effort;
    return *this;
  }
  virtual ~JointStatistics() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_mechanism_msgs/JointStatistics"); }
  inline static std::string __s_getMD5Sum() { return std::string("90fdc8acbce5bc783d8b4aec49af6590"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains the state of one joint of the pr2 robot.\n"
    "# This message is specificly designed for the pr2 robot. \n"
    "# A generic joint state message can be found in sensor_msgs::JointState\n"
    "\n"
    "# the name of the joint\n"
    "string name\n"
    "\n"
    "# the time at which these joint statistics were measured\n"
    "time timestamp\n"
    "\n"
    "# the position of the joint in radians\n"
    "float64 position\n"
    "\n"
    "# the velocity of the joint in radians per second\n"
    "float64 velocity\n"
    "\n"
    "# the measured joint effort \n"
    "float64 measured_effort\n"
    "\n"
    "# the effort that was commanded to the joint.\n"
    "# the actual applied effort might be different\n"
    "# because the safety code can limit the effort\n"
    "# a joint can apply\n"
    "float64 commanded_effort\n"
    "\n"
    "# a flag indicating if the joint is calibrated or not\n"
    "bool is_calibrated\n"
    "\n"
    "# a flag inidcating if the joint violated one of its position/velocity/effort limits\n"
    "# in the last publish cycle\n"
    "bool violated_limits\n"
    "\n"
    "# the total distance travelled by the joint, measured in radians.\n"
    "float64 odometer\n"
    "\n"
    "# the lowest position reached by the joint in the last publish cycle\n"
    "float64 min_position\n"
    "\n"
    "# the highest position reached by the joint in the last publish cycle\n"
    "float64 max_position\n"
    "\n"
    "# the maximum absolute velocity reached by the joint in the last publish cycle\n"
    "float64 max_abs_velocity\n"
    "\n"
    "# the maximum absolute effort applied by the joint in the last publish cycle\n"
    "float64 max_abs_effort\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + name.length(); // name
    __l += 8; // timestamp
    __l += 8; // position
    __l += 8; // velocity
    __l += 8; // measured_effort
    __l += 8; // commanded_effort
    __l += 1; // is_calibrated
    __l += 1; // violated_limits
    __l += 8; // odometer
    __l += 8; // min_position
    __l += 8; // max_position
    __l += 8; // max_abs_velocity
    __l += 8; // max_abs_effort
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_name_len = name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, name.c_str(), __ros_name_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timestamp.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, timestamp.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, position);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, velocity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, measured_effort);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, commanded_effort);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, is_calibrated);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, violated_limits);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, odometer);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, min_position);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_position);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_abs_velocity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_abs_effort);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_len);
    name = std::string((const char *)read_ptr, __ros_name_len);
    read_ptr += __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timestamp.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, timestamp.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, position);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, velocity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, measured_effort);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, commanded_effort);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, is_calibrated);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, violated_limits);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, odometer);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, min_position);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_position);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_abs_velocity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_abs_effort);
    return read_ptr;
  }
};

typedef boost::shared_ptr<JointStatistics> JointStatisticsPtr;
typedef boost::shared_ptr<JointStatistics const> JointStatisticsConstPtr;


}

#endif
