/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_mechanism/pr2_mechanism_msgs/msg/MechanismStatistics.msg.  Do not edit! */
#ifndef PR2_MECHANISM_MSGS_MECHANISMSTATISTICS_H
#define PR2_MECHANISM_MSGS_MECHANISMSTATISTICS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "pr2_mechanism_msgs/ActuatorStatistics.h"
#include "pr2_mechanism_msgs/JointStatistics.h"
#include "pr2_mechanism_msgs/ControllerStatistics.h"

namespace pr2_mechanism_msgs
{

//! \htmlinclude MechanismStatistics.msg.html

class MechanismStatistics : public ros::Message
{
public:
  typedef boost::shared_ptr<MechanismStatistics> Ptr;
  typedef boost::shared_ptr<MechanismStatistics const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<pr2_mechanism_msgs::ActuatorStatistics> _actuator_statistics_type;
  typedef std::vector<pr2_mechanism_msgs::JointStatistics> _joint_statistics_type;
  typedef std::vector<pr2_mechanism_msgs::ControllerStatistics> _controller_statistics_type;

  roslib::Header header;
  std::vector<pr2_mechanism_msgs::ActuatorStatistics> actuator_statistics;
  std::vector<pr2_mechanism_msgs::JointStatistics> joint_statistics;
  std::vector<pr2_mechanism_msgs::ControllerStatistics> controller_statistics;

  MechanismStatistics() : ros::Message()
  {
  }
  MechanismStatistics(const MechanismStatistics &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    actuator_statistics = copy.actuator_statistics;
    joint_statistics = copy.joint_statistics;
    controller_statistics = copy.controller_statistics;
  }
  MechanismStatistics &operator =(const MechanismStatistics &copy)
  {
    if (this == &copy)
      return *this;
    actuator_statistics.clear();
    joint_statistics.clear();
    controller_statistics.clear();
    header = copy.header;
    actuator_statistics = copy.actuator_statistics;
    joint_statistics = copy.joint_statistics;
    controller_statistics = copy.controller_statistics;
    return *this;
  }
  virtual ~MechanismStatistics() 
  {
    actuator_statistics.clear();
    joint_statistics.clear();
    controller_statistics.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_mechanism_msgs/MechanismStatistics"); }
  inline static std::string __s_getMD5Sum() { return std::string("b4a99069393681672c01f8c823458e04"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message describes the state of the pr2 mechanism. It contains the state of\n"
    "# each actuator, each joint, and each controller that is spawned in pr2_mechanism_control.\n"
    "\n"
    "Header header\n"
    "ActuatorStatistics[] actuator_statistics\n"
    "JointStatistics[] joint_statistics\n"
    "ControllerStatistics[] controller_statistics\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: pr2_mechanism_msgs/ActuatorStatistics\n"
    "# This message contains the state of an actuator on the pr2 robot.\n"
    "# An actuator contains a motor and an encoder, and is connected\n"
    "# to a joint by a transmission\n"
    "\n"
    "# the name of the actuator\n"
    "string name\n"
    "\n"
    "# the sequence number of the MCB in the ethercat chain. \n"
    "# the first device in the chain gets deviced_id zero\n"
    "int32 device_id\n"
    "\n"
    "# the time at which this actuator state was measured\n"
    "time timestamp\n"
    "\n"
    "# the encoder position, represented by the number of encoder ticks\n"
    "int32 encoder_count\n"
    "\n"
    "# The angular offset (in radians) that is added to the encoder reading, \n"
    "# to get to the position of the actuator. This number is computed when the referece\n"
    "# sensor is triggered during the calibration phase\n"
    "float64 encoder_offset\n"
    "\n"
    "# the encoder position in radians\n"
    "float64 position\n"
    "\n"
    "# the encoder velocity in encoder ticks per second\n"
    "float64 encoder_velocity\n"
    "\n"
    "# the encoder velocity in radians per second\n"
    "float64 velocity\n"
    "\n"
    "# the value of the calibration reading: low (false) or high (true)\n"
    "bool calibration_reading\n"
    "\n"
    "# bool to indicate if the joint already triggered the rising/falling edge of the reference sensor\n"
    "bool calibration_rising_edge_valid\n"
    "bool calibration_falling_edge_valid\n"
    "\n"
    "# the encoder position when the last rising/falling edge was observed. \n"
    "# only read this value when the calibration_rising/falling_edge_valid is true\n"
    "float64 last_calibration_rising_edge\n"
    "float64 last_calibration_falling_edge\n"
    "\n"
    "# flag to indicate if this actuator is enabled or not. \n"
    "# An actuator can only be commanded when it is enabled.\n"
    "bool is_enabled\n"
    "\n"
    "# indicates if the motor is halted. A motor can be halted because of a voltage or communication problem\n"
    "bool halted\n"
    "\n"
    "# the last current/effort command that was requested\n"
    "float64 last_commanded_current\n"
    "float64 last_commanded_effort\n"
    "\n"
    "# the last current/effort command that was executed by the actuator\n"
    "float64 last_executed_current\n"
    "float64 last_executed_effort\n"
    "\n"
    "# the last current/effort that was measured by the actuator\n"
    "float64 last_measured_current\n"
    "float64 last_measured_effort\n"
    "\n"
    "# the motor voltate\n"
    "float64 motor_voltage\n"
    "\n"
    "# the number of detected encoder problems \n"
    "int32 num_encoder_errors\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: pr2_mechanism_msgs/JointStatistics\n"
    "# This message contains the state of one joint of the pr2 robot.\n"
    "# This message is specificly designed for the pr2 robot. \n"
    "# A generic joint state message can be found in sensor_msgs::JointState\n"
    "\n"
    "# the name of the joint\n"
    "string name\n"
    "\n"
    "# the time at which these joint statistics were measured\n"
    "time timestamp\n"
    "\n"
    "# the position of the joint in radians\n"
    "float64 position\n"
    "\n"
    "# the velocity of the joint in radians per second\n"
    "float64 velocity\n"
    "\n"
    "# the measured joint effort \n"
    "float64 measured_effort\n"
    "\n"
    "# the effort that was commanded to the joint.\n"
    "# the actual applied effort might be different\n"
    "# because the safety code can limit the effort\n"
    "# a joint can apply\n"
    "float64 commanded_effort\n"
    "\n"
    "# a flag indicating if the joint is calibrated or not\n"
    "bool is_calibrated\n"
    "\n"
    "# a flag inidcating if the joint violated one of its position/velocity/effort limits\n"
    "# in the last publish cycle\n"
    "bool violated_limits\n"
    "\n"
    "# the total distance travelled by the joint, measured in radians.\n"
    "float64 odometer\n"
    "\n"
    "# the lowest position reached by the joint in the last publish cycle\n"
    "float64 min_position\n"
    "\n"
    "# the highest position reached by the joint in the last publish cycle\n"
    "float64 max_position\n"
    "\n"
    "# the maximum absolute velocity reached by the joint in the last publish cycle\n"
    "float64 max_abs_velocity\n"
    "\n"
    "# the maximum absolute effort applied by the joint in the last publish cycle\n"
    "float64 max_abs_effort\n"
    "\n"
    "================================================================================\n"
    "MSG: pr2_mechanism_msgs/ControllerStatistics\n"
    "# This message contains the state of one realtime controller\n"
    "# that was spawned in pr2_mechanism_control\n"
    "\n"
    "# the name of the controller\n"
    "string name\n"
    "\n"
    "# the time at which these controller statistics were measured\n"
    "time timestamp\n"
    "\n"
    "# bool that indicates if the controller is currently\n"
    "# in a running or a stopped state\n"
    "bool running\n"
    "\n"
    "# the maximum time the update loop of the controller ever needed to complete\n"
    "duration max_time\n"
    "\n"
    "# the average time the update loop of the controller needs to complete. \n"
    "# the average is computed in a sliding time window.\n"
    "duration mean_time\n"
    "\n"
    "# the variance on the time the update loop of the controller needs to complete.\n"
    "# the variance applies to a sliding time window.\n"
    "duration variance_time\n"
    "\n"
    "# the number of times this controller broke the realtime loop\n"
    "int32 num_control_loop_overruns\n"
    "\n"
    "# the timestamp of the last time this controller broke the realtime loop\n"
    "time time_last_control_loop_overrun\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_actuator_statistics_size(uint32_t __ros_new_size)
  {
    this->actuator_statistics.resize(__ros_new_size);
  }
  inline uint32_t get_actuator_statistics_size() const { return actuator_statistics.size(); }
  uint32_t calc_actuator_statistics_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t actuator_statistics_size = actuator_statistics.size();
    for (size_t i = 0; i < actuator_statistics_size; i++)
      l += actuator_statistics[i].serializationLength();
    return l;
  }
  inline void get_actuator_statistics_vec (std::vector<pr2_mechanism_msgs::ActuatorStatistics> &__ros_vec) const
  {
    __ros_vec = this->actuator_statistics;
  }
  inline void set_actuator_statistics_vec(const std::vector<pr2_mechanism_msgs::ActuatorStatistics> &__ros_vec)
  {
    this->actuator_statistics = __ros_vec;
  }
  void set_joint_statistics_size(uint32_t __ros_new_size)
  {
    this->joint_statistics.resize(__ros_new_size);
  }
  inline uint32_t get_joint_statistics_size() const { return joint_statistics.size(); }
  uint32_t calc_joint_statistics_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_statistics_size = joint_statistics.size();
    for (size_t i = 0; i < joint_statistics_size; i++)
      l += joint_statistics[i].serializationLength();
    return l;
  }
  inline void get_joint_statistics_vec (std::vector<pr2_mechanism_msgs::JointStatistics> &__ros_vec) const
  {
    __ros_vec = this->joint_statistics;
  }
  inline void set_joint_statistics_vec(const std::vector<pr2_mechanism_msgs::JointStatistics> &__ros_vec)
  {
    this->joint_statistics = __ros_vec;
  }
  void set_controller_statistics_size(uint32_t __ros_new_size)
  {
    this->controller_statistics.resize(__ros_new_size);
  }
  inline uint32_t get_controller_statistics_size() const { return controller_statistics.size(); }
  uint32_t calc_controller_statistics_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t controller_statistics_size = controller_statistics.size();
    for (size_t i = 0; i < controller_statistics_size; i++)
      l += controller_statistics[i].serializationLength();
    return l;
  }
  inline void get_controller_statistics_vec (std::vector<pr2_mechanism_msgs::ControllerStatistics> &__ros_vec) const
  {
    __ros_vec = this->controller_statistics;
  }
  inline void set_controller_statistics_vec(const std::vector<pr2_mechanism_msgs::ControllerStatistics> &__ros_vec)
  {
    this->controller_statistics = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_actuator_statistics_array_serialization_len(); // actuator_statistics
    __l += 4 + calc_joint_statistics_array_serialization_len(); // joint_statistics
    __l += 4 + calc_controller_statistics_array_serialization_len(); // controller_statistics
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __actuator_statistics_size = actuator_statistics.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __actuator_statistics_size);
    for (size_t i = 0; i < __actuator_statistics_size; i++)
      write_ptr = actuator_statistics[i].serialize(write_ptr, seq);
    uint32_t __joint_statistics_size = joint_statistics.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_statistics_size);
    for (size_t i = 0; i < __joint_statistics_size; i++)
      write_ptr = joint_statistics[i].serialize(write_ptr, seq);
    uint32_t __controller_statistics_size = controller_statistics.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __controller_statistics_size);
    for (size_t i = 0; i < __controller_statistics_size; i++)
      write_ptr = controller_statistics[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __actuator_statistics_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __actuator_statistics_size);
    set_actuator_statistics_size(__actuator_statistics_size);
    for (size_t i = 0; i < __actuator_statistics_size; i++)
      read_ptr = actuator_statistics[i].deserialize(read_ptr);
    uint32_t __joint_statistics_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_statistics_size);
    set_joint_statistics_size(__joint_statistics_size);
    for (size_t i = 0; i < __joint_statistics_size; i++)
      read_ptr = joint_statistics[i].deserialize(read_ptr);
    uint32_t __controller_statistics_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __controller_statistics_size);
    set_controller_statistics_size(__controller_statistics_size);
    for (size_t i = 0; i < __controller_statistics_size; i++)
      read_ptr = controller_statistics[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<MechanismStatistics> MechanismStatisticsPtr;
typedef boost::shared_ptr<MechanismStatistics const> MechanismStatisticsConstPtr;


}

#endif
