# autogenerated by genmsg_py from ActuatorStatistics.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime

class ActuatorStatistics(roslib.message.Message):
  _md5sum = "c37184273b29627de29382f1d3670175"
  _type = "pr2_mechanism_msgs/ActuatorStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message contains the state of an actuator on the pr2 robot.
# An actuator contains a motor and an encoder, and is connected
# to a joint by a transmission

# the name of the actuator
string name

# the sequence number of the MCB in the ethercat chain. 
# the first device in the chain gets deviced_id zero
int32 device_id

# the time at which this actuator state was measured
time timestamp

# the encoder position, represented by the number of encoder ticks
int32 encoder_count

# The angular offset (in radians) that is added to the encoder reading, 
# to get to the position of the actuator. This number is computed when the referece
# sensor is triggered during the calibration phase
float64 encoder_offset

# the encoder position in radians
float64 position

# the encoder velocity in encoder ticks per second
float64 encoder_velocity

# the encoder velocity in radians per second
float64 velocity

# the value of the calibration reading: low (false) or high (true)
bool calibration_reading

# bool to indicate if the joint already triggered the rising/falling edge of the reference sensor
bool calibration_rising_edge_valid
bool calibration_falling_edge_valid

# the encoder position when the last rising/falling edge was observed. 
# only read this value when the calibration_rising/falling_edge_valid is true
float64 last_calibration_rising_edge
float64 last_calibration_falling_edge

# flag to indicate if this actuator is enabled or not. 
# An actuator can only be commanded when it is enabled.
bool is_enabled

# indicates if the motor is halted. A motor can be halted because of a voltage or communication problem
bool halted

# the last current/effort command that was requested
float64 last_commanded_current
float64 last_commanded_effort

# the last current/effort command that was executed by the actuator
float64 last_executed_current
float64 last_executed_effort

# the last current/effort that was measured by the actuator
float64 last_measured_current
float64 last_measured_effort

# the motor voltate
float64 motor_voltage

# the number of detected encoder problems 
int32 num_encoder_errors


"""
  __slots__ = ['name','device_id','timestamp','encoder_count','encoder_offset','position','encoder_velocity','velocity','calibration_reading','calibration_rising_edge_valid','calibration_falling_edge_valid','last_calibration_rising_edge','last_calibration_falling_edge','is_enabled','halted','last_commanded_current','last_commanded_effort','last_executed_current','last_executed_effort','last_measured_current','last_measured_effort','motor_voltage','num_encoder_errors']
  _slot_types = ['string','int32','time','int32','float64','float64','float64','float64','bool','bool','bool','float64','float64','bool','bool','float64','float64','float64','float64','float64','float64','float64','int32']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   name,device_id,timestamp,encoder_count,encoder_offset,position,encoder_velocity,velocity,calibration_reading,calibration_rising_edge_valid,calibration_falling_edge_valid,last_calibration_rising_edge,last_calibration_falling_edge,is_enabled,halted,last_commanded_current,last_commanded_effort,last_executed_current,last_executed_effort,last_measured_current,last_measured_effort,motor_voltage,num_encoder_errors
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ActuatorStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.device_id is None:
        self.device_id = 0
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      if self.encoder_count is None:
        self.encoder_count = 0
      if self.encoder_offset is None:
        self.encoder_offset = 0.
      if self.position is None:
        self.position = 0.
      if self.encoder_velocity is None:
        self.encoder_velocity = 0.
      if self.velocity is None:
        self.velocity = 0.
      if self.calibration_reading is None:
        self.calibration_reading = False
      if self.calibration_rising_edge_valid is None:
        self.calibration_rising_edge_valid = False
      if self.calibration_falling_edge_valid is None:
        self.calibration_falling_edge_valid = False
      if self.last_calibration_rising_edge is None:
        self.last_calibration_rising_edge = 0.
      if self.last_calibration_falling_edge is None:
        self.last_calibration_falling_edge = 0.
      if self.is_enabled is None:
        self.is_enabled = False
      if self.halted is None:
        self.halted = False
      if self.last_commanded_current is None:
        self.last_commanded_current = 0.
      if self.last_commanded_effort is None:
        self.last_commanded_effort = 0.
      if self.last_executed_current is None:
        self.last_executed_current = 0.
      if self.last_executed_effort is None:
        self.last_executed_effort = 0.
      if self.last_measured_current is None:
        self.last_measured_current = 0.
      if self.last_measured_effort is None:
        self.last_measured_effort = 0.
      if self.motor_voltage is None:
        self.motor_voltage = 0.
      if self.num_encoder_errors is None:
        self.num_encoder_errors = 0
    else:
      self.name = ''
      self.device_id = 0
      self.timestamp = roslib.rostime.Time()
      self.encoder_count = 0
      self.encoder_offset = 0.
      self.position = 0.
      self.encoder_velocity = 0.
      self.velocity = 0.
      self.calibration_reading = False
      self.calibration_rising_edge_valid = False
      self.calibration_falling_edge_valid = False
      self.last_calibration_rising_edge = 0.
      self.last_calibration_falling_edge = 0.
      self.is_enabled = False
      self.halted = False
      self.last_commanded_current = 0.
      self.last_commanded_effort = 0.
      self.last_executed_current = 0.
      self.last_executed_effort = 0.
      self.last_measured_current = 0.
      self.last_measured_effort = 0.
      self.motor_voltage = 0.
      self.num_encoder_errors = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<i2Ii4d3B2d2B7di', self.device_id, self.timestamp.secs, self.timestamp.nsecs, self.encoder_count, self.encoder_offset, self.position, self.encoder_velocity, self.velocity, self.calibration_reading, self.calibration_rising_edge_valid, self.calibration_falling_edge_valid, self.last_calibration_rising_edge, self.last_calibration_falling_edge, self.is_enabled, self.halted, self.last_commanded_current, self.last_commanded_effort, self.last_executed_current, self.last_executed_effort, self.last_measured_current, self.last_measured_effort, self.motor_voltage, self.num_encoder_errors))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 129
      (self.device_id, self.timestamp.secs, self.timestamp.nsecs, self.encoder_count, self.encoder_offset, self.position, self.encoder_velocity, self.velocity, self.calibration_reading, self.calibration_rising_edge_valid, self.calibration_falling_edge_valid, self.last_calibration_rising_edge, self.last_calibration_falling_edge, self.is_enabled, self.halted, self.last_commanded_current, self.last_commanded_effort, self.last_executed_current, self.last_executed_effort, self.last_measured_current, self.last_measured_effort, self.motor_voltage, self.num_encoder_errors,) = struct.unpack('<i2Ii4d3B2d2B7di',str[start:end])
      self.calibration_reading = bool(self.calibration_reading)
      self.calibration_rising_edge_valid = bool(self.calibration_rising_edge_valid)
      self.calibration_falling_edge_valid = bool(self.calibration_falling_edge_valid)
      self.is_enabled = bool(self.is_enabled)
      self.halted = bool(self.halted)
      self.timestamp.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<i2Ii4d3B2d2B7di', self.device_id, self.timestamp.secs, self.timestamp.nsecs, self.encoder_count, self.encoder_offset, self.position, self.encoder_velocity, self.velocity, self.calibration_reading, self.calibration_rising_edge_valid, self.calibration_falling_edge_valid, self.last_calibration_rising_edge, self.last_calibration_falling_edge, self.is_enabled, self.halted, self.last_commanded_current, self.last_commanded_effort, self.last_executed_current, self.last_executed_effort, self.last_measured_current, self.last_measured_effort, self.motor_voltage, self.num_encoder_errors))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 129
      (self.device_id, self.timestamp.secs, self.timestamp.nsecs, self.encoder_count, self.encoder_offset, self.position, self.encoder_velocity, self.velocity, self.calibration_reading, self.calibration_rising_edge_valid, self.calibration_falling_edge_valid, self.last_calibration_rising_edge, self.last_calibration_falling_edge, self.is_enabled, self.halted, self.last_commanded_current, self.last_commanded_effort, self.last_executed_current, self.last_executed_effort, self.last_measured_current, self.last_measured_effort, self.motor_voltage, self.num_encoder_errors,) = struct.unpack('<i2Ii4d3B2d2B7di',str[start:end])
      self.calibration_reading = bool(self.calibration_reading)
      self.calibration_rising_edge_valid = bool(self.calibration_rising_edge_valid)
      self.calibration_falling_edge_valid = bool(self.calibration_falling_edge_valid)
      self.is_enabled = bool(self.is_enabled)
      self.halted = bool(self.halted)
      self.timestamp.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

