# autogenerated by genmsg_py from ControllerStatistics.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime

class ControllerStatistics(roslib.message.Message):
  _md5sum = "6d15d137eea402018e3c7c8dbecd4b95"
  _type = "pr2_mechanism_msgs/ControllerStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message contains the state of one realtime controller
# that was spawned in pr2_mechanism_control

# the name of the controller
string name

# the time at which these controller statistics were measured
time timestamp

# bool that indicates if the controller is currently
# in a running or a stopped state
bool running

# the maximum time the update loop of the controller ever needed to complete
duration max_time

# the average time the update loop of the controller needs to complete. 
# the average is computed in a sliding time window.
duration mean_time

# the variance on the time the update loop of the controller needs to complete.
# the variance applies to a sliding time window.
duration variance_time

# the number of times this controller broke the realtime loop
int32 num_control_loop_overruns

# the timestamp of the last time this controller broke the realtime loop
time time_last_control_loop_overrun
"""
  __slots__ = ['name','timestamp','running','max_time','mean_time','variance_time','num_control_loop_overruns','time_last_control_loop_overrun']
  _slot_types = ['string','time','bool','duration','duration','duration','int32','time']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   name,timestamp,running,max_time,mean_time,variance_time,num_control_loop_overruns,time_last_control_loop_overrun
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ControllerStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      if self.running is None:
        self.running = False
      if self.max_time is None:
        self.max_time = roslib.rostime.Duration()
      if self.mean_time is None:
        self.mean_time = roslib.rostime.Duration()
      if self.variance_time is None:
        self.variance_time = roslib.rostime.Duration()
      if self.num_control_loop_overruns is None:
        self.num_control_loop_overruns = 0
      if self.time_last_control_loop_overrun is None:
        self.time_last_control_loop_overrun = roslib.rostime.Time()
    else:
      self.name = ''
      self.timestamp = roslib.rostime.Time()
      self.running = False
      self.max_time = roslib.rostime.Duration()
      self.mean_time = roslib.rostime.Duration()
      self.variance_time = roslib.rostime.Duration()
      self.num_control_loop_overruns = 0
      self.time_last_control_loop_overrun = roslib.rostime.Time()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<2IB7i2I', self.timestamp.secs, self.timestamp.nsecs, self.running, self.max_time.secs, self.max_time.nsecs, self.mean_time.secs, self.mean_time.nsecs, self.variance_time.secs, self.variance_time.nsecs, self.num_control_loop_overruns, self.time_last_control_loop_overrun.secs, self.time_last_control_loop_overrun.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      if self.max_time is None:
        self.max_time = roslib.rostime.Duration()
      if self.mean_time is None:
        self.mean_time = roslib.rostime.Duration()
      if self.variance_time is None:
        self.variance_time = roslib.rostime.Duration()
      if self.time_last_control_loop_overrun is None:
        self.time_last_control_loop_overrun = roslib.rostime.Time()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 45
      (self.timestamp.secs, self.timestamp.nsecs, self.running, self.max_time.secs, self.max_time.nsecs, self.mean_time.secs, self.mean_time.nsecs, self.variance_time.secs, self.variance_time.nsecs, self.num_control_loop_overruns, self.time_last_control_loop_overrun.secs, self.time_last_control_loop_overrun.nsecs,) = struct.unpack('<2IB7i2I',str[start:end])
      self.running = bool(self.running)
      self.timestamp.canon()
      self.max_time.canon()
      self.mean_time.canon()
      self.variance_time.canon()
      self.time_last_control_loop_overrun.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<2IB7i2I', self.timestamp.secs, self.timestamp.nsecs, self.running, self.max_time.secs, self.max_time.nsecs, self.mean_time.secs, self.mean_time.nsecs, self.variance_time.secs, self.variance_time.nsecs, self.num_control_loop_overruns, self.time_last_control_loop_overrun.secs, self.time_last_control_loop_overrun.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      if self.max_time is None:
        self.max_time = roslib.rostime.Duration()
      if self.mean_time is None:
        self.mean_time = roslib.rostime.Duration()
      if self.variance_time is None:
        self.variance_time = roslib.rostime.Duration()
      if self.time_last_control_loop_overrun is None:
        self.time_last_control_loop_overrun = roslib.rostime.Time()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 45
      (self.timestamp.secs, self.timestamp.nsecs, self.running, self.max_time.secs, self.max_time.nsecs, self.mean_time.secs, self.mean_time.nsecs, self.variance_time.secs, self.variance_time.nsecs, self.num_control_loop_overruns, self.time_last_control_loop_overrun.secs, self.time_last_control_loop_overrun.nsecs,) = struct.unpack('<2IB7i2I',str[start:end])
      self.running = bool(self.running)
      self.timestamp.canon()
      self.max_time.canon()
      self.mean_time.canon()
      self.variance_time.canon()
      self.time_last_control_loop_overrun.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

