# autogenerated by genmsg_py from JointStatistics.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime

class JointStatistics(roslib.message.Message):
  _md5sum = "90fdc8acbce5bc783d8b4aec49af6590"
  _type = "pr2_mechanism_msgs/JointStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message contains the state of one joint of the pr2 robot.
# This message is specificly designed for the pr2 robot. 
# A generic joint state message can be found in sensor_msgs::JointState

# the name of the joint
string name

# the time at which these joint statistics were measured
time timestamp

# the position of the joint in radians
float64 position

# the velocity of the joint in radians per second
float64 velocity

# the measured joint effort 
float64 measured_effort

# the effort that was commanded to the joint.
# the actual applied effort might be different
# because the safety code can limit the effort
# a joint can apply
float64 commanded_effort

# a flag indicating if the joint is calibrated or not
bool is_calibrated

# a flag inidcating if the joint violated one of its position/velocity/effort limits
# in the last publish cycle
bool violated_limits

# the total distance travelled by the joint, measured in radians.
float64 odometer

# the lowest position reached by the joint in the last publish cycle
float64 min_position

# the highest position reached by the joint in the last publish cycle
float64 max_position

# the maximum absolute velocity reached by the joint in the last publish cycle
float64 max_abs_velocity

# the maximum absolute effort applied by the joint in the last publish cycle
float64 max_abs_effort

"""
  __slots__ = ['name','timestamp','position','velocity','measured_effort','commanded_effort','is_calibrated','violated_limits','odometer','min_position','max_position','max_abs_velocity','max_abs_effort']
  _slot_types = ['string','time','float64','float64','float64','float64','bool','bool','float64','float64','float64','float64','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   name,timestamp,position,velocity,measured_effort,commanded_effort,is_calibrated,violated_limits,odometer,min_position,max_position,max_abs_velocity,max_abs_effort
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(JointStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      if self.position is None:
        self.position = 0.
      if self.velocity is None:
        self.velocity = 0.
      if self.measured_effort is None:
        self.measured_effort = 0.
      if self.commanded_effort is None:
        self.commanded_effort = 0.
      if self.is_calibrated is None:
        self.is_calibrated = False
      if self.violated_limits is None:
        self.violated_limits = False
      if self.odometer is None:
        self.odometer = 0.
      if self.min_position is None:
        self.min_position = 0.
      if self.max_position is None:
        self.max_position = 0.
      if self.max_abs_velocity is None:
        self.max_abs_velocity = 0.
      if self.max_abs_effort is None:
        self.max_abs_effort = 0.
    else:
      self.name = ''
      self.timestamp = roslib.rostime.Time()
      self.position = 0.
      self.velocity = 0.
      self.measured_effort = 0.
      self.commanded_effort = 0.
      self.is_calibrated = False
      self.violated_limits = False
      self.odometer = 0.
      self.min_position = 0.
      self.max_position = 0.
      self.max_abs_velocity = 0.
      self.max_abs_effort = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<2I4d2B5d', self.timestamp.secs, self.timestamp.nsecs, self.position, self.velocity, self.measured_effort, self.commanded_effort, self.is_calibrated, self.violated_limits, self.odometer, self.min_position, self.max_position, self.max_abs_velocity, self.max_abs_effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 82
      (self.timestamp.secs, self.timestamp.nsecs, self.position, self.velocity, self.measured_effort, self.commanded_effort, self.is_calibrated, self.violated_limits, self.odometer, self.min_position, self.max_position, self.max_abs_velocity, self.max_abs_effort,) = struct.unpack('<2I4d2B5d',str[start:end])
      self.is_calibrated = bool(self.is_calibrated)
      self.violated_limits = bool(self.violated_limits)
      self.timestamp.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<2I4d2B5d', self.timestamp.secs, self.timestamp.nsecs, self.position, self.velocity, self.measured_effort, self.commanded_effort, self.is_calibrated, self.violated_limits, self.odometer, self.min_position, self.max_position, self.max_abs_velocity, self.max_abs_effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.timestamp is None:
        self.timestamp = roslib.rostime.Time()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 82
      (self.timestamp.secs, self.timestamp.nsecs, self.position, self.velocity, self.measured_effort, self.commanded_effort, self.is_calibrated, self.violated_limits, self.odometer, self.min_position, self.max_position, self.max_abs_velocity, self.max_abs_effort,) = struct.unpack('<2I4d2B5d',str[start:end])
      self.is_calibrated = bool(self.is_calibrated)
      self.violated_limits = bool(self.violated_limits)
      self.timestamp.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

