# autogenerated by genmsg_py from MechanismStatistics.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import pr2_mechanism_msgs.msg
import roslib.msg

class MechanismStatistics(roslib.message.Message):
  _md5sum = "b4a99069393681672c01f8c823458e04"
  _type = "pr2_mechanism_msgs/MechanismStatistics"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message describes the state of the pr2 mechanism. It contains the state of
# each actuator, each joint, and each controller that is spawned in pr2_mechanism_control.

Header header
ActuatorStatistics[] actuator_statistics
JointStatistics[] joint_statistics
ControllerStatistics[] controller_statistics

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: pr2_mechanism_msgs/ActuatorStatistics
# This message contains the state of an actuator on the pr2 robot.
# An actuator contains a motor and an encoder, and is connected
# to a joint by a transmission

# the name of the actuator
string name

# the sequence number of the MCB in the ethercat chain. 
# the first device in the chain gets deviced_id zero
int32 device_id

# the time at which this actuator state was measured
time timestamp

# the encoder position, represented by the number of encoder ticks
int32 encoder_count

# The angular offset (in radians) that is added to the encoder reading, 
# to get to the position of the actuator. This number is computed when the referece
# sensor is triggered during the calibration phase
float64 encoder_offset

# the encoder position in radians
float64 position

# the encoder velocity in encoder ticks per second
float64 encoder_velocity

# the encoder velocity in radians per second
float64 velocity

# the value of the calibration reading: low (false) or high (true)
bool calibration_reading

# bool to indicate if the joint already triggered the rising/falling edge of the reference sensor
bool calibration_rising_edge_valid
bool calibration_falling_edge_valid

# the encoder position when the last rising/falling edge was observed. 
# only read this value when the calibration_rising/falling_edge_valid is true
float64 last_calibration_rising_edge
float64 last_calibration_falling_edge

# flag to indicate if this actuator is enabled or not. 
# An actuator can only be commanded when it is enabled.
bool is_enabled

# indicates if the motor is halted. A motor can be halted because of a voltage or communication problem
bool halted

# the last current/effort command that was requested
float64 last_commanded_current
float64 last_commanded_effort

# the last current/effort command that was executed by the actuator
float64 last_executed_current
float64 last_executed_effort

# the last current/effort that was measured by the actuator
float64 last_measured_current
float64 last_measured_effort

# the motor voltate
float64 motor_voltage

# the number of detected encoder problems 
int32 num_encoder_errors


================================================================================
MSG: pr2_mechanism_msgs/JointStatistics
# This message contains the state of one joint of the pr2 robot.
# This message is specificly designed for the pr2 robot. 
# A generic joint state message can be found in sensor_msgs::JointState

# the name of the joint
string name

# the time at which these joint statistics were measured
time timestamp

# the position of the joint in radians
float64 position

# the velocity of the joint in radians per second
float64 velocity

# the measured joint effort 
float64 measured_effort

# the effort that was commanded to the joint.
# the actual applied effort might be different
# because the safety code can limit the effort
# a joint can apply
float64 commanded_effort

# a flag indicating if the joint is calibrated or not
bool is_calibrated

# a flag inidcating if the joint violated one of its position/velocity/effort limits
# in the last publish cycle
bool violated_limits

# the total distance travelled by the joint, measured in radians.
float64 odometer

# the lowest position reached by the joint in the last publish cycle
float64 min_position

# the highest position reached by the joint in the last publish cycle
float64 max_position

# the maximum absolute velocity reached by the joint in the last publish cycle
float64 max_abs_velocity

# the maximum absolute effort applied by the joint in the last publish cycle
float64 max_abs_effort

================================================================================
MSG: pr2_mechanism_msgs/ControllerStatistics
# This message contains the state of one realtime controller
# that was spawned in pr2_mechanism_control

# the name of the controller
string name

# the time at which these controller statistics were measured
time timestamp

# bool that indicates if the controller is currently
# in a running or a stopped state
bool running

# the maximum time the update loop of the controller ever needed to complete
duration max_time

# the average time the update loop of the controller needs to complete. 
# the average is computed in a sliding time window.
duration mean_time

# the variance on the time the update loop of the controller needs to complete.
# the variance applies to a sliding time window.
duration variance_time

# the number of times this controller broke the realtime loop
int32 num_control_loop_overruns

# the timestamp of the last time this controller broke the realtime loop
time time_last_control_loop_overrun
"""
  __slots__ = ['header','actuator_statistics','joint_statistics','controller_statistics']
  _slot_types = ['Header','pr2_mechanism_msgs/ActuatorStatistics[]','pr2_mechanism_msgs/JointStatistics[]','pr2_mechanism_msgs/ControllerStatistics[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,actuator_statistics,joint_statistics,controller_statistics
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(MechanismStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.actuator_statistics is None:
        self.actuator_statistics = []
      if self.joint_statistics is None:
        self.joint_statistics = []
      if self.controller_statistics is None:
        self.controller_statistics = []
    else:
      self.header = roslib.msg._Header.Header()
      self.actuator_statistics = []
      self.joint_statistics = []
      self.controller_statistics = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.actuator_statistics
      length = len(self.actuator_statistics)
      buff.write(struct.pack('<I', length))
      for val1 in self.actuator_statistics:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<i', val1.device_id))
        buff.write(struct.pack('<2I', val1.timestamp.secs, val1.timestamp.nsecs))
        buff.write(struct.pack('<i4d3B2d2B7di', val1.encoder_count, val1.encoder_offset, val1.position, val1.encoder_velocity, val1.velocity, val1.calibration_reading, val1.calibration_rising_edge_valid, val1.calibration_falling_edge_valid, val1.last_calibration_rising_edge, val1.last_calibration_falling_edge, val1.is_enabled, val1.halted, val1.last_commanded_current, val1.last_commanded_effort, val1.last_executed_current, val1.last_executed_effort, val1.last_measured_current, val1.last_measured_effort, val1.motor_voltage, val1.num_encoder_errors))
      #serialize self.joint_statistics
      length = len(self.joint_statistics)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_statistics:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<2I', val1.timestamp.secs, val1.timestamp.nsecs))
        buff.write(struct.pack('<4d2B5d', val1.position, val1.velocity, val1.measured_effort, val1.commanded_effort, val1.is_calibrated, val1.violated_limits, val1.odometer, val1.min_position, val1.max_position, val1.max_abs_velocity, val1.max_abs_effort))
      #serialize self.controller_statistics
      length = len(self.controller_statistics)
      buff.write(struct.pack('<I', length))
      for val1 in self.controller_statistics:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<2I', val1.timestamp.secs, val1.timestamp.nsecs))
        buff.write(struct.pack('<B', val1.running))
        buff.write(struct.pack('<2i', val1.max_time.secs, val1.max_time.nsecs))
        buff.write(struct.pack('<2i', val1.mean_time.secs, val1.mean_time.nsecs))
        buff.write(struct.pack('<2i', val1.variance_time.secs, val1.variance_time.nsecs))
        buff.write(struct.pack('<i', val1.num_control_loop_overruns))
        buff.write(struct.pack('<2I', val1.time_last_control_loop_overrun.secs, val1.time_last_control_loop_overrun.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.actuator_statistics
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.actuator_statistics = []
      for i in xrange(0, length):
        val1 = pr2_mechanism_msgs.msg.ActuatorStatistics()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.device_id,) = struct.unpack('<i',str[start:end])
        start = end
        end += 8
        (val1.timestamp.secs, val1.timestamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 117
        (val1.encoder_count, val1.encoder_offset, val1.position, val1.encoder_velocity, val1.velocity, val1.calibration_reading, val1.calibration_rising_edge_valid, val1.calibration_falling_edge_valid, val1.last_calibration_rising_edge, val1.last_calibration_falling_edge, val1.is_enabled, val1.halted, val1.last_commanded_current, val1.last_commanded_effort, val1.last_executed_current, val1.last_executed_effort, val1.last_measured_current, val1.last_measured_effort, val1.motor_voltage, val1.num_encoder_errors,) = struct.unpack('<i4d3B2d2B7di',str[start:end])
        val1.calibration_reading = bool(val1.calibration_reading)
        val1.calibration_rising_edge_valid = bool(val1.calibration_rising_edge_valid)
        val1.calibration_falling_edge_valid = bool(val1.calibration_falling_edge_valid)
        val1.is_enabled = bool(val1.is_enabled)
        val1.halted = bool(val1.halted)
        self.actuator_statistics.append(val1)
      #deserialize self.joint_statistics
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_statistics = []
      for i in xrange(0, length):
        val1 = pr2_mechanism_msgs.msg.JointStatistics()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.timestamp.secs, val1.timestamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 74
        (val1.position, val1.velocity, val1.measured_effort, val1.commanded_effort, val1.is_calibrated, val1.violated_limits, val1.odometer, val1.min_position, val1.max_position, val1.max_abs_velocity, val1.max_abs_effort,) = struct.unpack('<4d2B5d',str[start:end])
        val1.is_calibrated = bool(val1.is_calibrated)
        val1.violated_limits = bool(val1.violated_limits)
        self.joint_statistics.append(val1)
      #deserialize self.controller_statistics
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.controller_statistics = []
      for i in xrange(0, length):
        val1 = pr2_mechanism_msgs.msg.ControllerStatistics()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.timestamp.secs, val1.timestamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 1
        (val1.running,) = struct.unpack('<B',str[start:end])
        val1.running = bool(val1.running)
        start = end
        end += 8
        (val1.max_time.secs, val1.max_time.nsecs,) = struct.unpack('<2i',str[start:end])
        start = end
        end += 8
        (val1.mean_time.secs, val1.mean_time.nsecs,) = struct.unpack('<2i',str[start:end])
        start = end
        end += 8
        (val1.variance_time.secs, val1.variance_time.nsecs,) = struct.unpack('<2i',str[start:end])
        start = end
        end += 4
        (val1.num_control_loop_overruns,) = struct.unpack('<i',str[start:end])
        start = end
        end += 8
        (val1.time_last_control_loop_overrun.secs, val1.time_last_control_loop_overrun.nsecs,) = struct.unpack('<2I',str[start:end])
        self.controller_statistics.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.actuator_statistics
      length = len(self.actuator_statistics)
      buff.write(struct.pack('<I', length))
      for val1 in self.actuator_statistics:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<i', val1.device_id))
        buff.write(struct.pack('<2I', val1.timestamp.secs, val1.timestamp.nsecs))
        buff.write(struct.pack('<i4d3B2d2B7di', val1.encoder_count, val1.encoder_offset, val1.position, val1.encoder_velocity, val1.velocity, val1.calibration_reading, val1.calibration_rising_edge_valid, val1.calibration_falling_edge_valid, val1.last_calibration_rising_edge, val1.last_calibration_falling_edge, val1.is_enabled, val1.halted, val1.last_commanded_current, val1.last_commanded_effort, val1.last_executed_current, val1.last_executed_effort, val1.last_measured_current, val1.last_measured_effort, val1.motor_voltage, val1.num_encoder_errors))
      #serialize self.joint_statistics
      length = len(self.joint_statistics)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_statistics:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<2I', val1.timestamp.secs, val1.timestamp.nsecs))
        buff.write(struct.pack('<4d2B5d', val1.position, val1.velocity, val1.measured_effort, val1.commanded_effort, val1.is_calibrated, val1.violated_limits, val1.odometer, val1.min_position, val1.max_position, val1.max_abs_velocity, val1.max_abs_effort))
      #serialize self.controller_statistics
      length = len(self.controller_statistics)
      buff.write(struct.pack('<I', length))
      for val1 in self.controller_statistics:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<2I', val1.timestamp.secs, val1.timestamp.nsecs))
        buff.write(struct.pack('<B', val1.running))
        buff.write(struct.pack('<2i', val1.max_time.secs, val1.max_time.nsecs))
        buff.write(struct.pack('<2i', val1.mean_time.secs, val1.mean_time.nsecs))
        buff.write(struct.pack('<2i', val1.variance_time.secs, val1.variance_time.nsecs))
        buff.write(struct.pack('<i', val1.num_control_loop_overruns))
        buff.write(struct.pack('<2I', val1.time_last_control_loop_overrun.secs, val1.time_last_control_loop_overrun.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.actuator_statistics
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.actuator_statistics = []
      for i in xrange(0, length):
        val1 = pr2_mechanism_msgs.msg.ActuatorStatistics()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.device_id,) = struct.unpack('<i',str[start:end])
        start = end
        end += 8
        (val1.timestamp.secs, val1.timestamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 117
        (val1.encoder_count, val1.encoder_offset, val1.position, val1.encoder_velocity, val1.velocity, val1.calibration_reading, val1.calibration_rising_edge_valid, val1.calibration_falling_edge_valid, val1.last_calibration_rising_edge, val1.last_calibration_falling_edge, val1.is_enabled, val1.halted, val1.last_commanded_current, val1.last_commanded_effort, val1.last_executed_current, val1.last_executed_effort, val1.last_measured_current, val1.last_measured_effort, val1.motor_voltage, val1.num_encoder_errors,) = struct.unpack('<i4d3B2d2B7di',str[start:end])
        val1.calibration_reading = bool(val1.calibration_reading)
        val1.calibration_rising_edge_valid = bool(val1.calibration_rising_edge_valid)
        val1.calibration_falling_edge_valid = bool(val1.calibration_falling_edge_valid)
        val1.is_enabled = bool(val1.is_enabled)
        val1.halted = bool(val1.halted)
        self.actuator_statistics.append(val1)
      #deserialize self.joint_statistics
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_statistics = []
      for i in xrange(0, length):
        val1 = pr2_mechanism_msgs.msg.JointStatistics()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.timestamp.secs, val1.timestamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 74
        (val1.position, val1.velocity, val1.measured_effort, val1.commanded_effort, val1.is_calibrated, val1.violated_limits, val1.odometer, val1.min_position, val1.max_position, val1.max_abs_velocity, val1.max_abs_effort,) = struct.unpack('<4d2B5d',str[start:end])
        val1.is_calibrated = bool(val1.is_calibrated)
        val1.violated_limits = bool(val1.violated_limits)
        self.joint_statistics.append(val1)
      #deserialize self.controller_statistics
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.controller_statistics = []
      for i in xrange(0, length):
        val1 = pr2_mechanism_msgs.msg.ControllerStatistics()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.timestamp.secs, val1.timestamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 1
        (val1.running,) = struct.unpack('<B',str[start:end])
        val1.running = bool(val1.running)
        start = end
        end += 8
        (val1.max_time.secs, val1.max_time.nsecs,) = struct.unpack('<2i',str[start:end])
        start = end
        end += 8
        (val1.mean_time.secs, val1.mean_time.nsecs,) = struct.unpack('<2i',str[start:end])
        start = end
        end += 8
        (val1.variance_time.secs, val1.variance_time.nsecs,) = struct.unpack('<2i',str[start:end])
        start = end
        end += 4
        (val1.num_control_loop_overruns,) = struct.unpack('<i',str[start:end])
        start = end
        end += 8
        (val1.time_last_control_loop_overrun.secs, val1.time_last_control_loop_overrun.nsecs,) = struct.unpack('<2I',str[start:end])
        self.controller_statistics.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

