/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/pr2_mechanism/pr2_mechanism_msgs/srv/SwitchController.srv.  Do not edit! */
#ifndef SRV_PR2_MECHANISM_MSGS_SWITCHCONTROLLER_H
#define SRV_PR2_MECHANISM_MSGS_SWITCHCONTROLLER_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

namespace pr2_mechanism_msgs
{

struct SwitchController
{

inline static std::string getDataType() { return "pr2_mechanism_msgs/SwitchController"; }
inline static std::string getMD5Sum() { return "5e857dedf71d6f337975e15a1e7cfdd8"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef std::vector<std::string> _start_controllers_type;
  typedef std::vector<std::string> _stop_controllers_type;
  typedef int32_t _strictness_type;

  std::vector<std::string> start_controllers;
  std::vector<std::string> stop_controllers;
  int32_t strictness;
  const static int32_t BEST_EFFORT = 1;
  const static int32_t STRICT = 2;

  Request() : ros::Message(),
    strictness(0)
  {
  }
  Request(const Request &copy) : ros::Message(),
    strictness(copy.strictness)
  {
    (void)copy;
    start_controllers = copy.start_controllers;
    stop_controllers = copy.stop_controllers;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    start_controllers.clear();
    stop_controllers.clear();
    start_controllers = copy.start_controllers;
    stop_controllers = copy.stop_controllers;
    strictness = copy.strictness;
    return *this;
  }
  virtual ~Request() 
  {
    start_controllers.clear();
    stop_controllers.clear();
  }
  inline static std::string __s_getDataType() { return std::string("pr2_mechanism_msgs/SwitchControllerRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# The SwitchController service allows you stop a number of controllers\n"
    "# and start a number of controllers, all in one single timestep of the\n"
    "# pr2_mechanism_control control loop. \n"
    "\n"
    "# To switch controllers, specify \n"
    "#  * the list of controller names to start,\n"
    "#  * the list of controller names to stop, and\n"
    "#  * the strictness (BEST_EFFORT or STRICT)\n"
    "#    * STRICT means that switching will fail if anything goes wrong (an invalid\n"
    "#      controller name, a controller that failed to start, etc. )\n"
    "#    * BEST_EFFORT means that even when something goes wrong with on controller, \n"
    "#      the service will still try to start/stop the remaining controllers\n"
    "\n"
    "# The return value \"ok\" indicates if the controllers were switched\n"
    "# successfully or not.  The meaning of success depends on the \n"
    "# specified strictness.\n"
    "\n"
    "\n"
    "string[] start_controllers\n"
    "string[] stop_controllers\n"
    "int32 strictness\n"
    "int32 BEST_EFFORT=1\n"
    "int32 STRICT=2\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("5e857dedf71d6f337975e15a1e7cfdd8"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("pr2_mechanism_msgs/SwitchController"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_start_controllers_size(uint32_t __ros_new_size)
  {
    this->start_controllers.resize(__ros_new_size);
  }
  inline uint32_t get_start_controllers_size() const { return start_controllers.size(); }
  uint32_t calc_start_controllers_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t start_controllers_size = start_controllers.size();
    for (size_t i = 0; i < start_controllers_size; i++)
      l += 4 + start_controllers[i].length();
    return l;
  }
  inline void get_start_controllers_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->start_controllers;
  }
  inline void set_start_controllers_vec(const std::vector<std::string> &__ros_vec)
  {
    this->start_controllers = __ros_vec;
  }
  void set_stop_controllers_size(uint32_t __ros_new_size)
  {
    this->stop_controllers.resize(__ros_new_size);
  }
  inline uint32_t get_stop_controllers_size() const { return stop_controllers.size(); }
  uint32_t calc_stop_controllers_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t stop_controllers_size = stop_controllers.size();
    for (size_t i = 0; i < stop_controllers_size; i++)
      l += 4 + stop_controllers[i].length();
    return l;
  }
  inline void get_stop_controllers_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->stop_controllers;
  }
  inline void set_stop_controllers_vec(const std::vector<std::string> &__ros_vec)
  {
    this->stop_controllers = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_start_controllers_array_serialization_len(); // start_controllers
    __l += 4 + calc_stop_controllers_array_serialization_len(); // stop_controllers
    __l += 4; // strictness
    __l += 0; // BEST_EFFORT
    __l += 0; // STRICT
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __start_controllers_size = start_controllers.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __start_controllers_size);
    for (size_t i = 0; i < __start_controllers_size; i++)
    {
      unsigned __ros_start_controllers_i__len = start_controllers[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_start_controllers_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, start_controllers[i].c_str(), __ros_start_controllers_i__len);
    }
    uint32_t __stop_controllers_size = stop_controllers.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __stop_controllers_size);
    for (size_t i = 0; i < __stop_controllers_size; i++)
    {
      unsigned __ros_stop_controllers_i__len = stop_controllers[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_stop_controllers_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, stop_controllers[i].c_str(), __ros_stop_controllers_i__len);
    }
    SROS_SERIALIZE_PRIMITIVE(write_ptr, strictness);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __start_controllers_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __start_controllers_size);
    set_start_controllers_size(__start_controllers_size);
    for (size_t i = 0; i < __start_controllers_size; i++)
    {
      unsigned __ros_start_controllers_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_start_controllers_i__len);
    start_controllers[i] = std::string((const char *)read_ptr, __ros_start_controllers_i__len);
    read_ptr += __ros_start_controllers_i__len;
    }
    uint32_t __stop_controllers_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __stop_controllers_size);
    set_stop_controllers_size(__stop_controllers_size);
    for (size_t i = 0; i < __stop_controllers_size; i++)
    {
      unsigned __ros_stop_controllers_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_stop_controllers_i__len);
    stop_controllers[i] = std::string((const char *)read_ptr, __ros_stop_controllers_i__len);
    read_ptr += __ros_stop_controllers_i__len;
    }
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, strictness);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef uint8_t _ok_type;

  uint8_t ok;

  Response() : ros::Message(),
    ok(0)
  {
  }
  Response(const Response &copy) : ros::Message(),
    ok(copy.ok)
  {
    (void)copy;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    ok = copy.ok;
    return *this;
  }
  virtual ~Response() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_mechanism_msgs/SwitchControllerResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "bool ok\n"
    "\n"
    "\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("5e857dedf71d6f337975e15a1e7cfdd8"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("pr2_mechanism_msgs/SwitchController"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 1; // ok
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, ok);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, ok);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
